//
//  RCTAppleHealthKit+NSUserDefaults.m
//  RCTAppleHealthKit
//
//  Created by rosswang on 2017/12/12.
//  Copyright © 2017年 Greg Wilson. All rights reserved.
//

#import "RCTAppleHealthKit+NSUserDefaults.h"
#import "RCTAppleHealthKit+Utils.h"

@implementation RCTAppleHealthKit (Methods_UserDefaults)

- (void)set_UserDefaultsByKey:(NSDictionary *)input callback:(RCTResponseSenderBlock)callback
{
    NSString *str = [input objectForKey:@"key"];
    NSData *newAnchor = [[NSUserDefaults standardUserDefaults] objectForKey:[@"New" stringByAppendingString:str]];
    [[NSUserDefaults standardUserDefaults] setObject:newAnchor forKey:[@"Old" stringByAppendingString:str]];
    NSDictionary *result = @{
                             @"status" : @(true)
                             };
    callback(@[[NSNull null], result]);
}

- (void)reset_UserDefaultsByKey:(NSDictionary *)input callback:(RCTResponseSenderBlock)callback
{
    NSString *str = [input objectForKey:@"key"];
    [[NSUserDefaults standardUserDefaults] setObject:HKAnchoredObjectQueryNoAnchor forKey:[@"Old" stringByAppendingString:str]];
    NSDictionary *result = @{
                             @"status" : @(true)
                             };
    callback(@[[NSNull null], result]);
}

- (void)get_TimestampByKey:(NSDictionary *)input callback:(RCTResponseSenderBlock)callback
{
    NSString *key = [input objectForKey:@"key"];
    NSURL *url = [[[NSFileManager defaultManager] URLsForDirectory:NSDocumentDirectory inDomains:NSUserDomainMask] lastObject];
    NSString *filePath = [url.path stringByAppendingPathComponent:key];
    NSString *content = [NSString stringWithContentsOfFile:filePath encoding:NSUTF8StringEncoding error:nil];
    
    if (content != nil) {
        NSDictionary *result = @{
                   @"timestamp" : content
                   };
        callback(@[[NSNull null], result]);
    } else {
        callback(@[[NSNull null]]);
    }
}

- (void)set_TimestampByKey:(NSDictionary *)input callback:(RCTResponseSenderBlock)callback
{
    NSString *key = [input objectForKey:@"key"];
    NSString *timestamp = [input objectForKey:@"timestamp"];
    NSURL *url = [[[NSFileManager defaultManager] URLsForDirectory:NSDocumentDirectory inDomains:NSUserDomainMask] lastObject];
    NSString *filePath = [url.path stringByAppendingPathComponent:key];
    NSError *error;
    BOOL ok = [timestamp writeToFile:filePath atomically:YES encoding:NSUTF8StringEncoding error:&error];
    NSDictionary *result;
    if (!ok) {
        NSLog(@"Error writing file at %@\n%@", filePath, [error localizedFailureReason]);
        result = @{
                   @"status" : @(false)
                   };
    } else {
        result = @{
                   @"status" : @(true)
                   };
    }
    callback(@[[NSNull null], result]);
}

@end
